<?php

include_once "CQuartet.php";

class CMidiGen {
  var $Position=0; // Position of last midi event
  var $PositionV=0; // Position of voice start
  var $txt; // Resulting Text
  var $tar; // Text Array
  // Constants
  var $Step=12;
  var $BaseNote=12;
  var $BaseCh=14;
  var $PrePause=1440;
  // Random parameters
  var $len_rnd_min=0; // random length to add/subtract for each note
  var $len_rnd_max=1; // random length to add/subtract for each note
  var $post_rnd_min=-1; // random length to add/subtract for each note (end) in percent of note length
  var $post_rnd_max=-1; // random length to add/subtract for each note (end) in percent of note length
  
  function __construct($tcount = 2) {
    $this->AddLine('MFile 1 '.$tcount.' '.round($this->Step*30));
    $this->PositionV = $pos=$this->PrePause;
    //$this->StartTrack();
    //$this->EndTrack();
    //$this->StartTrack("Piano");
    //$this->AddLine("1 Meta TrkEnd");
  }
  
  function StartTrack($name="") {
    $this->AddLine('MTrk');
		$this->AddLine('0 PrCh ch='.$this->BaseCh.' p=0');
    if ($name != "") $this->AddLine('0 Meta TrkName "'.$name.'"');
  }
  
  function AddLine($st) {
    $this->txt.=$st."\r\n";
  }
  
  function AddElement($t, $st) {
    $this->tar[$t][]=$st;
  }
  
  function AddVoice($Q, $v, $sibelius=0, $skip=0) {
    // Local copy
    $ncount = $Q->ncount;
    $vcount = $Q->vcount;
    $note = $Q->note[$v];
    $vol = $Q->vol[$v];
    $retrigger = $Q->retrigger[$v];
    $off = $Q->off[$v];
    $len = $Q->len;
    $temp = $Q->temp;
    $pause = $Q->pause;
    $mode_key = $Q->mode_key;
    $chord = $Q->chord;
    $pos=$this->PositionV;
    if ($v == 0) $this->AddElement(0, '0 Tempo 200000');
    if ($sibelius) for ($i=0; $i<$skip; $i++) $pos += $this->Step * $len[$i]; 
    for ($i=$skip; $i<$ncount; $i++) if ($note[$i]>0) {
      $fi=$i;
      //if ($off[$i]>0) echo "$v:$i ".$off[$i]." Offset<br>";
      $step=$this->Step;
      //if (($temp[$i]>0) && ($strict==0)) $step=$this->Step * 60 / $temp[$i];
      $len5=round($step*($len[$i]));
      $len6=round($step*($len[$i]+$pause[$i]));
			$lyric = "";
      if ($sibelius) {
        $len2=round($step*($len[$i]));
        if (($pause[$i] > 0) && ($v == 0)) $lyric .= "P";
        if (($Q->reprise_first[$i] > 0) && ($v == 0)) {
				  if ($lyric != "") $lyric .= ",";
					if ($Q->reprise_measures[$i]>0) $lyric .= "R".$Q->reprise_measures[$i];
					  else $lyric .= "Rs".$Q->reprise_steps_left[$i];
				}
				//$this->AddElement(1, ($pos+42) . ' Meta Lyric "R'.$Q->reprise_steps_left[$i].'"');
      } else {
        $len2=round($step*($len[$i]+$pause[$i]));
      }
      //echo "$step<br>";
      //if ($i==$ncount-1) $len2=$len2*4;
			if ($v==0) {
			  if (($i==0) || ($mode_key[$i] != $mode_key[$i-1])) {
			    $sig=midi_sig($mode_key[$i]);
			    if ($sig < 0) $b=1; else $b=0;
			    $this->AddElement(1, ($pos) . ' KeySig ' . $sig . ' major');
			    //$this->AddElement(1, ($pos) . ' Meta Lyric "[' . get_notename($mode_key[$i], $b) . ']"');
			  }
			  $tmp = $temp[$i];
			  if (($sibelius) && ($pause[$i]>0)) $tmp *= $len[$i]/($len[$i]+$pause[$i]);
			  $this->AddElement(0, ($pos) . ' Tempo ' . round(60000000/$tmp));
	      if ($chord[$i] != $chord[$i-1]) {
  	      $ch=$chord[$i];
  	      if ($ch=="") $ch="?";
			    if ($Q->rmcount[$i]>2) $this->AddElement(1, ($pos) . ' Meta Text "'.$ch.'"');
			  }
			}
			if ($lyric != "") $this->AddElement(1, ($pos) . ' Meta Lyric "'.$lyric.'"');
      for ($x=1; $x<500; $x++) {
        if ($i+1 >= $ncount) break;
        if ($note[$i+1]!=$note[$i]) break;
        if ($retrigger[$i+1]>0) break;
			  $lyric = "";
        //echo "Inc note $v:$i $pos:$len2 ". ($pos+$len2-1) ."<br>";
			  if ($v==0) {
			    if ($mode_key[$i+1] != $mode_key[$i]) {
  			    $sig=midi_sig($mode_key[$i+1]);
  			    if ($sig < 0) $b=1; else $b=0;
  			    $this->AddElement(1, ($pos+$len2) . ' KeySig ' . $sig . ' major');
  			    //$this->AddElement(1, ($pos+$len2) . ' Meta Lyric "[' . get_notename($mode_key[$i+1], $b) . ']"');
			      //$this->AddElement(1, ($pos+$len2-1) . ' KeySig ' . midi_sig($mode_key[$i+1]). ' major');
			    }
			    $tmp = $temp[$i+1];
			    if (($sibelius) && ($pause[$i+1]>0)) $tmp *= $len[$i+1]/($len[$i+1]+$pause[$i+1]);
			    $this->AddElement(0, ($pos+$len2) . ' Tempo ' . round(60000000/$tmp));
			  	if ($chord[$i+1] != $chord[$i]) {
  	        $ch=$chord[$i+1];
  	        if ($ch=="") $ch="?";
			      if ($Q->rmcount[$i+1]>2) $this->AddElement(1, ($pos+$len2) . ' Meta Text "'.($ch).'"');
			    }
			  }
			  $step2=$step;
			  //if (($temp[$i]>0) && ($strict==0)) $step2=$this->Step * 60 / $temp[$i+1];
        $len6 += round($step*($len[$i]+$pause[$i]));
			  if ($sibelius) {
          //if (($pause[$i+1] > 0) && ($v == 0)) $this->AddElement(1, ($pos+$len2) . ' Meta Lyric "P"');
          //if (($Q->reprise_first[$i+1] > 0) && ($v == 0)) $this->AddElement(1, ($pos+$len2+42) . ' Meta Lyric "R'.$Q->reprise_steps_left[$i+1].'"');
          if (($pause[$i+1] > 0) && ($v == 0)) $lyric .= "P";
          if (($Q->reprise_first[$i+1] > 0) && ($v == 0)) {
				    if ($lyric != "") $lyric .= ",";
					  if ($Q->reprise_measures[$i+1]>0) $lyric .= "R".$Q->reprise_measures[$i+1];
					    else $lyric .= "Rs".$Q->reprise_steps_left[$i+1];
				  }
					$len8 = $len2;
			    $len2 += round($step2 * ($len[$i+1]));
			  } else {
			    $len2 += round($step2 * ($len[$i+1]+$pause[$i+1]));
			  }
			  if ($lyric != "") $this->AddElement(1, ($pos+$len8) . ' Meta Lyric "'.$lyric.'"');
        $i++;
      }
			//if ($i > ($ncount-2)) $len2 += $step*240;
			$len4=0;
			$len3=$len2-1;
			if ($sibelius) {
			  $len3=$len5-1;
			} else {
        $len4 = round(mt_rand( $step * $this->len_rnd_min, $step * $this->len_rnd_max) + ($step * $off[$fi]/100));
        $len3 = $len3 + mt_rand( $this->post_rnd_min * $len3 / 100, $this->post_rnd_max * $len3 / 100);
        //if ($off[$fi]>0) echo "$v:$fi ".$off[$fi]." x $step is $len4 to $len3 over ".round(($len[$fi]+$pause[$fi])*$step)."<br>";
			}
		  if ($pos + $len4 < 1) $len4 = 1-$pos;
      $this->AddElement(1, ($pos + $len4) . 
          " On ch=".($this->BaseCh)." n=".($note[$i]+$this->BaseNote)." v=".round($vol[$i]));
      $this->AddElement(1, ($pos + $len3) . 
          " Off ch=".($this->BaseCh)." n=".($note[$i]+$this->BaseNote)." v=".round($vol[$i]));
      if (($v == $vcount-1) && ($Q->note[$vcount][$fi]>$note[$fi]) && ($sibelius == 0)) {
        //echo "$i:$fi:$v Extend up ".$Q->note[$vcount][$fi]." with off ".$Q->off[$vcount][$fi]." and vol ".$Q->vol[$vcount][$fi]."<br>";
        $len7 = round(mt_rand( $step * $this->len_rnd_min, $step * $this->len_rnd_max) + ($step * $Q->off[$vcount][$fi]/100));
        $this->AddElement(1, ($pos + $len7) . 
            " On ch=".($this->BaseCh)." n=".($Q->note[$vcount][$fi]+$this->BaseNote)." v=".round($Q->vol[$vcount][$fi]));
        $this->AddElement(1, ($pos + $len3) . 
            " Off ch=".($this->BaseCh)." n=".($Q->note[$vcount][$fi]+$this->BaseNote)." v=".round($Q->vol[$vcount][$fi]));
      }
      if (($v == 0) && ($Q->note[-1][$fi]>0) && ($sibelius == 0)) {
        //echo "$i:$fi:$v Extend down ".$Q->note[-1][$fi]." with off ".$Q->off[-1][$fi]." and vol ".$Q->vol[-1][$fi]."<br>";
        $len7 = round(mt_rand( $step * $this->len_rnd_min, $step * $this->len_rnd_max) + ($step * $Q->off[-1][$fi]/100));
        $this->AddElement(1, ($pos + $len7) . 
            " On ch=".($this->BaseCh)." n=".($Q->note[-1][$fi]+$this->BaseNote)." v=".round($Q->vol[-1][$fi]));
        $this->AddElement(1, ($pos + $len3) . 
            " Off ch=".($this->BaseCh)." n=".($Q->note[-1][$fi]+$this->BaseNote)." v=".round($Q->vol[-1][$fi]));
      }
      // Record positions
      $pos += $len2;
      $this->Position = max($pos, $this->Position);
    } else {
      //$pos += $step*$len[$i];
      //$this->Position = max($pos, $this->Position);
			//echo "Pause at $i $pos<br>";
    }
    //echo "Voice $v ended on $i at ".$this->Position."<br>";
  }
  
  function Compile($t) {
    sort($this->tar[$t], SORT_NUMERIC);
    for ($i=0; $i<count($this->tar[$t]); $i++) {
      $this->AddLine($this->tar[$t][$i]);
    }
    unset($this->tar[$t]);
  }
  
  function EndTrack() {
    $this->AddLine($this->Position+1 . " Meta TrkEnd");
    $this->AddLine("TrkEnd");
  }
}

?>
