<?php

class CQSettings {
  var $debug=1; // Debug level
  var $ncount = 100; // Number of generated notes
  // Output voice variables
  var $note;
  var $len;
  var $len_i; // Index of current len structure
  var $vol;
	var $temp;
	var $pause;
	var $retrigger; //[v][i]
  // Local vol variables
	var $vol2; // Volume before SM
  var $vol_sm; // Smooth modeling result
  var $vol_vel;
  var $vol_acc;
  var $vol_len; // Change of vol on len
  var $vol_note; // Change of vol on note
  var $vol_jump; // Change of vol on jump
  // Vol constants
  var $vol_min=0;
  var $vol_max=127;
  var $vol_vel_min=-5;
  var $vol_vel_max=5;
  var $vol_sm_min=-10;
  var $vol_sm_max=35;
  var $vol_acc_min=-2;
  var $vol_acc_max=2;
  var $vol_acc_step=1;
  var $vol_c_len=20; // Coefficient to increase volume for short notes
  var $vol_c_pitch=10; // Coefficient to increase volume for high notes
  var $vol_c_jump=3; // Coefficient to increase volume for long jumping notes
  var $vol_start_mul=0.7; // Coefficient to decrease volume at start
  var $vol_start=8; // Number of starting steps to change volume
  var $vol_stop_mul=1; // Coefficient to decrease volume at stop
  var $vol_stop=10; // Number of stopping steps to change volume
  // Local note variables
  var $hit; // [i][v] Equals 1 for moving or retriggered voice
  var $note_changed; // [i][v] $quals 1 for moving voice
  var $hits; // [i] Equals number of hits per step
  var $note_past; // [i][v] Equals len from the moment the note was hit to the beginning of the step 
  var $note_same; // Equals 1 for notes that were selected for mv but left unchanged
	var $note_len; // Length of note from triggering to the end of step
  var $note_locked; // Shows how much time the note cannot be moved
  var $note_density; // Orchestral density shows: 1 if all moving voices move up, -1 if all move down, 0 if some move up and some down
	var $nchange; // Difference between note[$i] and note[$i-1] 
  var $note_cont; // Contradicting notes fine
  var $note_g; // Sign of gravitation used (1 for rising, -1 for lowering acceleration)
  var $note_free1; // Number of free diatonic steps above (2) and below (1) note
  var $note_free2;
  var $note_win1; // Limiting notes above (2) and below (1) note for choose
  var $note_win2;
  var $note_diss; // Interval to the closest dissonating note or zero if no dissonants
  var $note_diss_a; // [i][v][v2] - if not zero, shows that note dissonates with v2 note
  var $note_dw; // Maximum weight of the discord, in which this note participates
  var $note_dv; // Discording voice
  var $note_si; // Strict interval moving wrong
  var $diss_str; // String
  var $retry; // Number of tries for NoteMut_Move
  var $retry2; // Number of tries for NoteMut
  var $retry_voice; // Number of tries for NoteMut inside
  var $retry_arp; // Number of tries for Arpeggio
  var $mcount; // Number of moving voices
  var $rmcount; // Number of really moved voices (changed by samenote)
  var $mv; // Moving voices (1 for move)
  var $mvp; // Current probabilities of voices to move
  var $dcount; // Number of diss
  var $icount; // Number of interval violations
  var $rcount; // Number of resolution violations
  var $ccount; // Number of contradictions
  var $lcount; // Number of loiter
  var $dvcount; // Number of diss with particular voice
  var $dvcount2; // Number of diss with particular voice (without regard to note fade out)
  var $fine; // Total fine
	var $retrig_c; // Local count of retriggers
  // Note alter local variables
  var $culm; // Shows if culmination here
  var $note_cht; // Shows that note suffered chromatic turn alteration
  var $note_chi; // Shows that note suffered chromatic intro alteration
  var $note_chs; // Shows that note suffered chromatic shift alteration
  var $note_loi; // Shows note loiter rating
  // Loiter constants
  var $loiter_int = 2; // Maximum interval to consider loiter
  var $loiter_max = 4; // Maximum loiter fine to allow
  var $loiter_steps = 6; // Number of steps to analyse for loiter
  var $loiter_max_alter = 0; // Maximum loiter fine to allow when analysing altered notes
  // Note alter constants
  var $note_alter_fine_max = 2; // Maximum fine increase with note alteration allowed
  var $note_alter_win1=25; // Minimum number of notes at the beginning, that cannot be altered
  var $note_alter_win2=25; // Minimum number of notes at the end, that cannot be altered
  var $note_alter_space=1; // Minimum  number of steps between alterations
  var $note_alter_search=10; // Number of steps forward to search for altered note
  var $cht_dir_p = array(10, 90); // Probabilities to accept down and up cht
  var $cht_jump_max=2; // Maximum jumps before and after chromatic turn in semitones (before applying turn)
  var $cht_jump_min=2; // Minimum jumps before and after chromatic turn in semitones (before applying turn)
  var $cht_len_max=25; // Maximum len of chromatic turn
  var $cht_temp_min=150; // Minimum tempo of chromatic alteration
  var $cht_temp1 = 2; // Tempo window to check before chs
  var $cht_temp2 = 2; // Tempo window to check after chs
  var $cht_count_max=1; // Maximum number of hit voices near chromatic alteration
  var $cht_count1 = 2; // Hit voices window to check before chs
  var $cht_count2 = 2; // Hit voices window to check after chs
  var $cht_win_min = 2; // Minimum window between the changing note and next voice from the side of decreasing interval (when altered)
  var $cht_p = array( 0 => 100, 1 => 100, 2 => 100, 3 => 100, 4 => 100, 5 => 100); // Probability of chromatic turn if possible by voice number
  var $cht_vol_c = 50; // Percent of volume to take when making cht
  var $cht_len1 = 2; // Len window to check before cht
  var $cht_len2 = 2; // Len window to check after cht
  var $chi_dia_mul=10; // Percentage multiplier for alteration probability when diatonic movement is in progress
  var $chi_dir_p = array(10, 100); // Probabilities to accept down and up chi
  var $chi_jump_max=2; // Maximum jump after chromatic introduction in semitones (before applying change)
  var $chi_jump_min=2; // Minimum jump after chromatic introduction in semitones (before applying change)
  var $chi_len_max=25; // Maximum len of chromatic turn
  var $chi_temp_min=130; // Minimum tempo of chromatic alteration
  var $chi_temp1 = 2; // Tempo window to check before chs
  var $chi_temp2 = 2; // Tempo window to check after chs
  var $chi_count_max=1; // Maximum number of hit voices near chromatic alteration
  var $chi_count1 = 2; // Hit voices window to check before chs
  var $chi_count2 = 2; // Hit voices window to check after chs
  var $chi_win_min = 2; // Minimum window between the changnig note and next voice from the side of decreasing interval (when altered)
  var $chi_p = array( 0 => 100, 1 => 100, 2 => 100, 3 => 100, 4 => 100, 5 => 100); // Probability of chromatic turn if possible by voice number
  var $chi_vol_c = 50; // Percent of volume to take when making chi
  var $chi_len1 = 2; // Len window to check before chi
  var $chi_len2 = 2; // Len window to check after chi
  var $chs_dir_p = array(80, 15); // Probabilities to accept down and up alteration (shift)
  var $chs_jump_max=2; // Maximum jump before chromatic alteration in semitones (before applying change)
  var $chs_jump_min=2; // Minimum jump before chromatic alteration in semitones (before applying change)
  var $chs_len_max=25; // Maximum len of chromatic alteration
  var $chs_temp_min=130; // Minimum tempo of chromatic alteration
  var $chs_temp1 = 2; // Tempo window to check before chs
  var $chs_temp2 = 2; // Tempo window to check after chs
  var $chs_count_max=1; // Maximum number of hit voices near chromatic alteration
  var $chs_count1 = 2; // Hit voices window to check before chs
  var $chs_count2 = 2; // Hit voices window to check after chs
  var $chs_win_min = 2; // Minimum window between the changnig note and next voice from the side of decreasing interval (when altered)
  var $chs_p = array( 0 => 0, 1 => 0, 2 => 0, 3 => 100, 4 => 100, 5 => 100); // Probability of chromatic alteration if possible by voice number
  var $chs_vol_c = 50; // Percent of volume to take when making chi
  var $chs_len1 = 2; // Len window to check before chs
  var $chs_len2 = 2; // Len window to check after chs
  // Note gravitation: 2 for upper limit, 1 for lower limit
  var $note_grav_minfree1=3;
	var $note_grav_p1=100; // Probability in percent of cutting above window for note when free down is greater than 1
  var $note_grav_dist1=6; // Distance in semitones from the limit, where probability remains constant
  var $note_grav_decr1=10; // Decrease of probability in percent below lim-dist
  var $note_grav_minfree2=3;
  var $note_grav_p2=100; // Probability in percent of cutting above window for note when free down is greater than 1
  var $note_grav_dist2=10; // Distance in semitones from the limit, where probability remains constant
  var $note_grav_decr2=10; // Decrease of probability in percent below lim-dist
	// Arpeggio local variables
	var $off; // Offset for current note
	var $arp; // Shows arpeggio was here
	// Arpeggio constants
	var $arp_p = array (0 => 0, 1=> 0, 2=> 50, 3=> 80, 4=> 80); // Probability of arpeggio by rmcount
	var $arp_vol = array(0 => 1, 1 => 0.9, 2 => 0.9, 3 => 0.8, 4 => 0.7, 5 => 0.5);
	var $arp_len_min = 80; // Minimum length (with pause), when arpeggio is possible
	var $arp_inc_min = 200;  
	var $arp_inc_max = 600; 
	var $arp_off_min = 100;
	var $arp_off_max = 600;
	var $arp_off_rnd = 20;
	var $arp_off_dec = 2;
	var $arp_min_step = 10;
	var $arp_ret_max = 45; // Maximum note pitch, that is still locked from retriggering in arpeggio
	var $arp_extend_p2 = 100; // Probability to extend arpeggio one octave above
	var $arp_extend_min_len2 = 30;
	var $arp_extend_p1 = 0; // Probability to extend arpeggio one octave below
	var $arp_extend_min_len1 = 50;
	var $arp_extend_vol1 = 70; // Percentage of volume of closest voice
	var $arp_extend_vol2 = 70; // Percentage of volume of closest voice
	var $arp_ret_dvc_max = 8; // Maximum dvcount2 for note to allow retrigger
  // Note constants
  var $note_retrigger_p; // Probability of not changing note to rerigger
  var $retrigger_space_min = 2; // Minimum number of steps between hit (move or retrigger) and retrigger in the same voice
  var $retrigger_mul_time; // Multiplicates note_retrigger_p for particular time % $measure
  var $retrigger_diss=0; // Multiplies by this much / dvcount if note evaluated has dissonating intervals
  var $retrigger_mul_len; // Multiplicates note_retrigger_p for particular len
  var $pause_p=30; // Base probability of a pause occurence (also recurring)
  var $pause_dec = 70; // Percentage of probability that is left after each pause generation
  var $pause_max=180; // Maximum length of a sigle pause
  var $pause_min= array( 120 =>  120, 60 =>  60, 45 => 60, 30 =>  60, 24 =>  60, 20 =>  60, 15 =>  60);
	var $pause_len_mul = array( 120 =>  1, 60 =>  1, 45 => 0.01, 30 =>  1, 24 =>  0.1, 20 =>  0.02, 15 =>  0.01);
	var $pause_ch_mul; // Multiplies pause_p based on time and chord type
	var $pause_ch_mul_def; // Multiplies pause_p based on chord type if on some other time
	var $pause_step_min = 10; // Minimum number of steps between pauses
	var $culm_bass_p=40; // Probability to move down to bass after culmination
	var $culm_bass_mul=30; // Multiplicator for probability of bass voice to move 
	var $culm_jump_min=2; // Minimal interval for considering a jumping culmination
	var $culm_mul=20; // Multiplies pause_p when culmination detected
	var $culm_win1=26; // Number of notes to search around to find culmination
	var $culm_win2=26; // Number of notes to search around to find culmination
	var $culm_p=80; // Percent of culminations to detect
	var $culm_temp = array(0.95, 0.9, 0.85, 0.8, 0.6, 0.2, 0.5, 0.8, 0.85, 0.9, 0.95); // Tempo multiplication array
	var $culm_temp_r = 5; // Radius of tempo multiplication
	var $culm_temp_len_mul = array( 120 =>  2, 60 =>  2, 45 => 1.5, 30 =>  1.5, 24 =>  1.5, 20 =>  1.3, 15 =>  1); // Divider for tempo decrease
	var $reprise_temp = array(0.9, 0.85, 0.75, 0.6, 0.75, 0.85, 0.9); // Tempo multiplication array
	var $reprise_temp_r = 3; // Radius of tempo multiplication
	var $reprise_temp_len_mul = array( 120 =>  2, 60 =>  2, 45 => 1.5, 30 =>  1.5, 24 =>  1.5, 20 =>  1.3, 15 =>  1); // Divider for tempo decrease
  var $pause_mcount_mul = array( 1 =>  0.05, 2 => 0.4, 3 =>  0.6, 4 =>  1);
	var $pause_nodcount = 1;
	var $pause_noicount = 0;
	var $pause_noccount = 1;
  var $diss_mul_p=10; // Voice move probability multiplicator for discording notes
  var $smo_mul_p=0; // Voice move probability multiplicator for smothered notes (where max(free)<2)
  var $smo_a = array(45 => 3);
  var $smo_a_def = 2;
  var $samenote_p= array( 1 =>  1, 2 => 0, 3 =>  10, 4 =>  10); // Probability of allowing same note when chosing voice move
  var $samenote_retrigger_mul = 5; // Multiplier for retrigger_p when samenote occurs
  var $samenote_retrigger_mul2 = 100000; // Multiplier for retrigger_p when samenote occurs
  var $prime_p = 0; // Probability of including prime in possible moves (limiting)
	var $note_min_len = array (30 => 90, 40 => 50, 50 => 40, 60 => 30); // Minimal len between notes by pitch (for locking)
	var $locked_c = array(55 => 0, 120 => 0.02); // Coefficient to multiply the mv_p for locked note 
	//var $note_min_len = array (30 => 60, 45 => 45, 50 => 30, 60 => 10); // Minimal len between notes by pitch (for locking)
	var $note_max_len; // Maximum note length by voice, after which mv_p multiplication takes place
	var $note_max_len_mul; // Multiplies mv_p by overlen
	var $voice_repeat_mul = array (1, 1, 1); // Multiplies mv_p around last moved voice 
	var $voice_repeat_r = 1; // Radius of multiplication. -1 turns algorithm off
	var $voice_repeat_mcount_mul = array( 1 =>  5, 2 => 2, 3 =>  1, 4 => 0.5); // Multiplies mv_p based on mcount
	var $voice_repeat_len_mul = array( 120 => 1, 60 => 1, 45 => 1, 30 => 1, 24 => 1.5, 20 => 2, 15 => 3); // Multiplies mv_p based on len
	var $voice_repeat_p = 100; // Probability of voice repeat multiplication
  var $note_min = array(0 => 28);
  var $note_min_max = 30;
  var $note_min_min = 20;
  var $note_min_step = 1;
  var $note_min_dir = -1; // Not constant! Direction of changing
  var $note_max = array(0 => 80);
  var $note_max_max = 85;
  var $note_max_min = 70;
  var $note_max_step = 1;
  var $note_max_dir = -1; // Not constant! Direction of changing
  var $diss_max = 0; // Maximum number of dissonants which is allowed (including weights and repeats)
  var $si_max = 0; // Maximum number of strict intervals violations (including weights and repeats)
  var $resolution_max = 0; // Maximum number of resolution violations (including weights)
	var $contra_max = 1; // Maximum number of contradictions per position allowed  (including weights and repeats)
	var $dens_allow_p = 100; // Probability to allow density violation. If not allowed, it counts as $dens_fine in fine
	var $dens_fine = 1;
	var $unlock_fine = 100; // Fine multiplicator for the number of note_lock violations 
  var $diss_a_def = array (1 => 3, 2 => 1, 6 => 3, 10 => 1, 11 => 3); // Dissonant weight (relative intervals)
  var $diss_a = array (45 => array(1 => 10, 2 => 10, 3 => 10, 4 => 10, 6 => 10, 8 =>8, 9 => 8, 10 => 10, 11 => 10)); // Dissonant weight for notes lower than x (absolute intervals only)
  var $diss_pedal=50; // Reduce dissonance weight to this percent when note is not hit in the step
  var $diss_w_past=4800; // Length in past that will reduce vol from 127 to 0
  var $diss_w_vol=1; // Coefficient of weight shape decreasing with vol
  var $diss_w_note=5; // Maximum note for all pieces
  var $diss_c=10; // Multiplies dcount before fine
  var $vol_left; // [v][i] Left volume of the continuous note at the end of the step
  var $bad_mv = array (6, 10, 11, 13, 14 );
  var $int_strict = array (0, 7);
  var $mcount_p; // Voice move numbers probabilities
  var $mv_p; // Voice number move probabilities
  var $note_d_def = array(5, 5);
  var $note_d = array(45 => array(8, 8), 60 => array(5, 5), 200 => array(8, 8));
  var $vcount;
  // Local tempo variables
	var $temp2; // Before SM
	var $temp_dlen; // Decrease by dlen
	var $temp_len; // Decrease by lena
	var $temp_culm; // Decrease by culm
	var $temp_reprise; // Decrease by reprise
	var $temp_sm2; // Decrease by sm
	var $temp_mcount; // Decrease by mcounta
  var $temp_sm = array(0 => 200); // Smooth modeling result
  var $temp_vel;
  var $temp_acc;
  // Tempo constants
  var $temp_min=0;
  var $temp_max=300;
  var $temp_vel_min=-40;
  var $temp_vel_max=40;
  var $temp_sm_min=0;
  var $temp_sm_max=200;
  var $temp_acc_min=-20;
  var $temp_acc_max=20;
  var $temp_acc_step=10;
	var $temp_sm_c1 = 10; // Scalar radius
	var $temp_sm_c2 = 10; // Percentage radius
  var $temp_mcounta= array(1, 2, 3, 4, 5, 4.5, 3.5, 2.5, 1.5); // Array of mcount averaging coefficients
	var $temp_mcount_r=4; // Radius of averaging mcount
	var $temp_mcount_c=10; // Coefficient of effect of mcount on tempo
	var $temp_mcount_off=1; // Offset of mcountaa from len
	var $temp_lena= array(1, 2, 3, 4, 5, 4.5, 3.5, 2.5, 1.5); // Array of len averaging coefficients
	var $temp_len_r=4; // Radius of averaging len
	var $temp_len_c;
	var $temp_len_off=2; // Offset of lena from len
	var $temp_a=250; // Coefficient of effect of len on tempo
	var $temp_len_min; // Minimum 
	//var $temp_b=15; // Coefficient of effect of len on tempo
	var $temp_dlen_c;
	var $temp_dlen_c_def;
	var $temp_dlen_c2;
	var $temp_dlen_c2_def;
	var $temp_dlen_c3;
	var $temp_dlen_c3_def;
	var $temp_dlena= array(1, 2, 3, 4, 5, 10, 0, 0, 0, 0, 0); // Array of dlen averaging coefficients
	var $temp_dlena2= array(1, 2, 3, 4, 5, 10, 0, 0, 0, 0, 0); // Array of dlen averaging coefficients
	var $temp_dlena3= array(0, 0, 0, 0, 0, 0,  6, 4, 3, 2, 1); // Array of dlen averaging coefficients
	var $temp_dlen_r=5; // Radius of averaging dlen
	var $temp_dlen_off=0; // Offset of dlena from len
  var $temp_start_mul=0.6; // Coefficient to multiply tempo at start
  var $temp_start=10; // Number of starting steps to change volume
  var $temp_stop_mul=0.5; // Coefficient to multiply tempo at stop
  var $temp_stop=10; // Number of starting steps to change volume
  var $temp_stop_min = 120; // Minimum tempo of the last step, which still allows tempo envelope 
  // Local len variables
  var $time; // Passed time since first note without tempo consideration
  var $rtime; // Real passed time since first note
  var $rlen; // Real length of a step
  var $measure = 120; // Measure size
  var $len_repeat;
  // Len constants
  var $len_min=15;
  var $len_max=120;
  var $len_ch_p; // Probability of changing len
  var $len_che_p; // Probability of changing len at the end 
  var $len_ch_stop = 15; // Number of finishing steps to change
  var $len_ch_stop2 = 5;  // Number of finishing steps to hold che_p
  var $len_st_repeat; // Base repeat of state
  var $time_mcount_mul; // Multiplicates mcount_p for particular time % $measure
  var $len_mcount_mul; // Multiplicates mcount_p for particular len
  // Note tries
  var $try_max = 30;
  var $try_mul = 2; // powered with mcount-1 and multiplied by try_max
  //var $try_mcount_p=100; // Probability of decreasing mcount if cannot minimise fine  
  //var $try_mv_p=100; // Probability of changing moving voice if mcount=1 and cannot minimise fine
	var $sfine; // Fine statistics
	var $try2_max = 5; // Outer tries of NoteMut
	var $try_fine = 0; // Maximum fine acceptable for outer tries
	var $try2_fine = 1; // Maximum fine acceptable for outer tries
	var $try2_mv = 10; // Divides mvp for voices that lead to bad moves previously
	// Chords
	var $chord; // Chord string name
	var $chord_i; // Index for ch_a
	var $chord_st; // String of weights of different guesses sorted
	var $chord_bass; // Difference between bass and chord tonal center
	var $chord_type; // 1 for single note, 2 for interval, 3 for 3 and more notes
	var $ch_a;
	var $ch_a_type; // Shows what chord_type would be set if chord is detected
	// End of piece constants
  var $len_stop_min=60; // Minimum len to search from the end
  var $mcount_stop_min=3; // Minimum mcount to search from the end
  var $stop_cut=10; // Number of steps to search from the end for cut
  // Melody character
  var $mel_t; // Tonal, dominant and subdominant melody rating
  var $mel_d;
  var $mel_s;
  var $mel_av = 5; // Average last 5 steps
  // Dissonance resolutions
  var $resolution1 = array(0, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0); // Shows if lower  note of this interval must resolve diatonically up (1) or down (-1)
  var $resolution2 = array(0,  0,  0, 0, 0, 0, 0, 0, 0, 0, -1, -1); // Shows if higher note of this interval must resolve diatonically up (1) or down (-1)
  var $note_res; // [v][i] If not zero, shows that note should resolve up (1) or down (-1) diatonically
  var $note_rv; // [v][i] If not zero, shows that note resolution was violated
  // Logging
  var $log_handle; // Log file handle
  var $mtime_start; // Start microtime
  var $mtime; // Microtime delta from start for each step
  // Diatonic movements
  var $dia; // Shows voice that is moving diatonically
  var $dia_count; // Shows number of steps from the beginning of the diatonic movement
  var $dia_dir; // 1 for moving up, -1 for moving down
  var $dia_len_max = 24; // Maximum step length for diatonic movement start 
  var $dia_len_max2 = 30; // Maximum step length for diatonic movement continuation
  var $dia_pitch_min = 47;
  var $dia_int_min = 10;
  var $dia_max = 4; // Maximum length of diatonic movements in steps
  var $dia_space = 10; // Minimum number of steps between diatonic movements
  var $dia_v_min = 1; // Minimum voice index that can be eligible for diatonic movement
  var $dia_p = 50; // Probability to accept diatonic movement, when it is possible
  var $dia_cut_p = 0; // Probability to stop diatonic movement without cause
  var $dia_steps_analyse = 5; // Number of steps of movement to analyse when deciding which direction to choose and if it is bad
  var $dia_fine_max = 2; // Maximum average fine to accept
  var $dia_fine_max2 = 3; // Maximum fine to accept
  var $dia_mode_mul = 100; // Multiplier for mode change probability if diatonic movement is in progress
  var $dia_stop = 20; // Number of finishing steps where diatonic movement is prohibited
  // Hidden tritone
  var $hidden_tritone;
	// Local mode variables
  var $mode;
  var $mode_key;
  var $mode_sig; // Midi key signature
  // Mode constants
  var $mode_div=480; // Positions in time to change mode
  var $mode_mut_p=60;
  var $mode_mut_min=-1; // for diatonic
  var $mode_mut_max=1; // for diatonic
  var $mode_stop=13; // Number of last steps where mode changes are prohibited
  // Reprise (0 for no note change, 1 for note change) 
  var $reprise_div =  array(1, 120); // Positions in time to start reprise 
  var $reprise_size_min = array(0, 480); // Size of reprise in time
  var $reprise_size_max = array(120, 4800);
  var $reprise_measures_p = array(0, array(4 => 10, 8 => 50, 12 => 250, 16 => 1000)); // Allowed size of reprise in measures with their probabilities
  var $reprise_incap = array(0, 0); // Probability to allow incapsulation of previous reprises
  var $reprise_incap_notes = array(0, 0); // Probability to allow incapsulation of previous reprised notes
  var $reprise_steps_min = array(3, 2); // Size of reprise in steps
  var $reprise_steps_max = array(5, 200);
  var $reprise_len_min = array(0, 0); // Note length inside the reprise
  var $reprise_len_max = array(46, 480);
  var $reprise_p = array(0, 60); // Probability of reprise
  var $reprise_rep_min = array(1, 1); // Number of repeats
  var $reprise_rep_max = array(4, 2); 
  //var $reprise_note = array(0, 1); // If you must repeat notes and modes
  var $reprise_oldmode_p = array(100, 0); // Probability of allowing to change mode
  var $reprise_oldvol_p = array(0, 0); // Probability of allowing to change volume
  var $reprise_abort = array(40, 35); // Percentage of steps to abort last reprise
  var $reprise_note_finish = array(100, 30); // Percentage of steps to allow newnotes at the end of each reprise repeat
  var $normalize_vol_c=0.5; // Coefficient to multiply vol for constant notes that were normalized
  var $reprise_stop = 15; // Number of steps at the end of piece to prohibit reprise
  var $reprise_start = 15; // Number of steps at the beginning of piece to prohibit reprise
  var $reprise_fine_max = 10; // Maximum fine for reprise accepted without throwing old notes away
  // Reprise local variables
  var $reprise_rep; // Number of repeats of current reprise left
  var $reprise_steps_left; // Number of steps left in current reprise repeat
  var $reprise_steps; // Number of steps in current reprise repeat
  var $reprise_type; // Type of reprise  
  var $reprise_oldnotes; // Shows if old notes must be maintained for this step
  var $reprise_oldvol; // Shows if old vol must be maintained for this step
  var $reprise_oldmode; // Shows if old mode must be maintained for this step
  var $note_normalized; // [i][v] Shows if this note was constant but was normalized
  var $reprise_first; // [i] Shows if this is first step of reprise occurence (equals 1 for each repeat of a reprise)
  var $reprise_measures; // [i] Shows number of measures for first step
  var $reprise_template; // [i] Shows number of steps forward to the repeating step
  
  function __construct($vcount) {
    $this->StartTimer();
    $this->rtime[0] = 0.8; // Compensate for MidiGen->PrePause
    $this->vcount = $vcount;
    // Note maximum length
    $ml=320;
    $mlm=5;
	  $this->note_max_len = array(0 => $ml, 1 => $ml, 2 => $ml, 3 => $ml, 4 => $ml, 5 => $ml); // Maximum note length by voice, after which mv_p multiplication takes place
	  $this->note_max_len_mul = array(0 => $mlm, 1 => $mlm, 2 => $mlm, 3 => $mlm, 4 => $mlm, 5 => $mlm); // Multiplies mv_p by overlen
	  // Coefficient of effect of len on tempo
	  $ml = 1;
	  $this->temp_len_c = array(240 => 60*$ml, 120 => 50*$ml, 60 => 40*$ml, 45 => 35*$ml, 30 => 30*$ml, 24 => 37*$ml, 20 => 33*$ml, 15 => 3*$ml);
	  // Divider on tempo decrease before len increase from first len to second len
	  $this->temp_dlen_c3[15] =  array( 120 => 1, 60 => 1.4, 45 => 1.4, 30 => 2.5, 24 => 1.3, 20 => 1.2, 15 => 1); 
	  $this->temp_dlen_c3_def  = array( 120 => 1, 60 => 1.4, 45 => 1.4, 30 => 1.7, 24 => 1.3, 20 => 1.2, 15 => 1); 
	  // Divider on tempo decrease when len increase to this len
	  $this->temp_dlen_c2_def =  array( 120 => 1, 60 => 1, 45 => 1, 30 => 1.3, 24 => 1.2, 20 => 1.2, 15 => 1); 
	  // Divider on tempo decrease when len decrease from first len to second len
	  $this->temp_dlen_c[30] =   array( 120 => 1, 60 => 1, 45 => 1, 30 => 1, 24 => 1.2, 20 => 1.5, 15 => 3);  
	  $this->temp_dlen_c[45] =   array( 120 => 1, 60 => 1, 45 => 1, 30 => 1, 24 => 1.2, 20 => 1.5, 15 => 2);  
	  $this->temp_dlen_c_def =   array( 120 => 1, 60 => 1, 45 => 1, 30 => 1, 24 => 1.2, 20 => 1.5, 15 => 2);  
    // Voice moves
    $this->mcount_p[1] = 30;
    $this->mcount_p[2] = 10;
    $this->mcount_p[3] = 3;
    $this->mcount_p[4] = 5;
    // Probability to change each voice
    $this->mv_p[0] = 20;
    $this->mv_p[1] = 40;
    $this->mv_p[2] = 70;
    $this->mv_p[3] = 50;
    $this->mv_p[4] = 35;
    $this->mv_p[5] = 30;
    // Probability to change from one len to another
    $this->len_ch_p[ 60] = array(120 =>   0, 60 =>  40, 45 =>   8, 30 =>  80, 24 =>   5, 20 =>   5, 16 =>  8, 15 =>   0);
    $this->len_ch_p[ 45] = array(120 =>   0, 60 =>  20, 45 =>   4, 30 =>  10, 24 =>   0, 20 =>   0, 16 =>  0, 15 =>   0);
    $this->len_ch_p[ 30] = array(120 =>   0, 60 =>  20, 45 =>   8, 30 =>  10, 24 =>  50, 20 =>  40, 16 =>  8, 15 =>   0);
    $this->len_ch_p[ 24] = array(120 =>   0, 60 =>  20, 45 =>   0, 30 =>  20, 24 =>  20, 20 =>   0, 16 =>  0, 15 =>   0);
    $this->len_ch_p[ 20] = array(120 =>   0, 60 =>  20, 45 =>   0, 30 =>  20, 24 =>  10, 20 => 100, 16 =>  0, 15 => 100);
    $this->len_ch_p[ 16] = array(120 =>   0, 60 =>  20, 45 =>   0, 30 =>  10, 24 =>   0, 20 =>   0, 16 =>  0, 15 =>   0);
    $this->len_ch_p[ 15] = array(120 =>   0, 60 =>   0, 45 =>   0, 30 =>  10, 24 =>  10, 20 => 200, 16 =>  0, 15 => 400);
    // Probability multiplicator for len_ch_p at the end
    $this->len_che_p[ 60]= array(120 =>   0, 60 =>  10, 45 =>   0, 30 =>  80, 24 =>   0, 20 =>   0, 16 => 0, 15 =>   0);
    $this->len_che_p[ 30]= array(120 =>   0, 60 =>  60, 45 =>   0, 30 =>  10, 24 =>   5, 20 =>   0, 16 => 0, 15 =>   0);
    $this->len_che_p[ 45]= array(120 =>   0, 60 =>  60, 45 =>   0, 30 =>  10, 24 =>   5, 20 =>   0, 16 => 0, 15 =>   0);
    $this->len_che_p[ 24]= array(120 =>   0, 60 =>  20, 45 =>   0, 30 =>  20, 24 =>   0, 20 =>   0, 16 => 0, 15 =>   0);
    $this->len_che_p[ 20]= array(120 =>   0, 60 =>  20, 45 =>   0, 30 =>  20, 24 =>   5, 20 =>   0, 16 => 0, 15 =>   0);
    $this->len_che_p[ 16]= array(120 =>   0, 60 =>  60, 45 =>   0, 30 =>  10, 24 =>   5, 20 =>   0, 16 => 0, 15 =>   0);
    $this->len_che_p[ 15]= array(120 =>   0, 60 =>   0, 45 =>   0, 30 =>  80, 24 =>   5, 20 =>   0, 16 => 0, 15 =>   0);
    // Probability multiplicator fo len_ch_p at the end
    //$this->len_ch_stop_mul=array(120 =>   0, 60 =>   2, 30 =>   1, 24 => 0.5, 20 => 0.2, 15 => 0.1); 
    // Multiplier for mcount depending on len
    $this->len_mcount_mul[120] = array(1 =>  0, 2 =>  0, 3 =>  0,  4 =>  1);
    $this->len_mcount_mul[ 60] = array(1 =>  0, 2 =>  0, 3 =>  1,  4 =>  1);
    $this->len_mcount_mul[ 45] = array(1 =>  3, 2 =>  2, 3 =>  1,  4 =>  1);
    $this->len_mcount_mul[ 30] = array(1 =>  5, 2 =>  2, 3 =>  1,  4 =>  1);
    $this->len_mcount_mul[ 24] = array(1 => 10, 2 =>  2, 3 =>  1,  4 =>  0);
    $this->len_mcount_mul[ 20] = array(1 => 10, 2 =>  2, 3 => 0.2, 4 =>  0);
    $this->len_mcount_mul[ 15] = array(1 => 20, 2 =>  1, 3 =>  0,  4 =>  0);
    // Multiplicates mcount_p for particular time % $measure
    $this->time_mcount_mul[  0] = array(1 =>  1, 2 =>  1, 3 =>  1, 4 => 50);
    // Retrigger by voice number
    $rp=2;
    $this->note_retrigger_p = array( 0 => $rp, 1 => $rp*1.2, 2 => $rp*1.6, 3 => $rp*1.4, 4 => $rp*1, 5 => $rp*0.5);
    // Multiplicates note_retrigger_p for particular time % $measure with mcount as key
    $this->retrigger_mul_time[  0] = array(1 =>  1, 2 =>  1, 3 =>  1, 4 => 5);
    // Multiplicates note_retrigger_p for particular len
    $this->retrigger_mul_len = array(15 =>  0.2, 20 =>  1, 24 =>  3, 30 => 4, 60 => 5, 120 => 6);
    // Minimum repeat count for a state
    $this->len_st_repeat[120] = 1;
    $this->len_st_repeat[ 60] = 1;
    $this->len_st_repeat[ 45] = array(45, 15);
    $this->len_st_repeat[ 30] = 2;
    $this->len_st_repeat[ 24] = 5;
    $this->len_st_repeat[ 20] = 3;
    $this->len_st_repeat[ 16] = array(15, 45);
    $this->len_st_repeat[ 15] = 2;
    // Starting mode
    $this->SetMode(0, 0);
    // Starting notes
    $this->len[0] = 60;
    $this->len_i[0] = 60;
    $this->mcount[0]=4;
    for ($v=0; $v<$this->vcount; $v++) {
      $this->vol_acc[$v][0] = 0;
      $this->vol_vel[$v][0] = 0;
      $this->vol_sm[$v][0] = mt_rand($this->vol_min, $this->vol_max);
      $this->vol[$v][0] = mt_rand(0, 60);
    }
    $this->CreateNotes(0, 36, array(12, 4, 3, 5, 4));
    // Chords
		// Notes                    C     D     E  F     G     A     H
    $this->ch_a[""]= array     (1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0);
    $this->ch_a["7"]= array    (1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0);
    $this->ch_a["maj7"]= array (1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1);
    $this->ch_a["m"]= array    (1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0);
    $this->ch_a["m7"]= array   (1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0);
    $this->ch_a["o7"]= array   (1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0);
    $this->ch_a["%7"]= array   (1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0);
    $this->ch_a["o"]= array    (1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0);
    $this->ch_a["aug"]= array    (1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0);
    $this->ch_a["aug7"]= array   (1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0);
    $this->ch_a["7b9"]= array  (1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0);
    $this->ch_a["mb9"]= array  (1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0);
    $this->ch_a["m7b9"]= array (1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0);
    $this->ch_a["ad9"]= array  (1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0);
    $this->ch_a["ad13"]= array (1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0);
    $this->ch_a["9"]= array    (1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0);
    $this->ch_a["13"]= array   (1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0);
    $this->ch_a["mad9"]= array (1, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0);
    $this->ch_a["mad13"]= array(1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0);
    $this->ch_a["m9"]= array   (1, 0, 1, 1, 0, 0, 0, 1, 0, 0, 1, 0);
    $this->ch_a["m13"]= array  (1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0);
    $this->ch_a["sus4"]= array (1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0);
    $this->ch_a["sus2"]= array (1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0);
    $this->ch_a["7sus4"]=array (1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 0);
    $this->ch_a["7sus2"]=array (1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1, 0);
    $this->ch_a["maj7sus4"]= array (1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1);
    $this->ch_a["maj7sus2"]= array (1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 1);
    $this->ch_a["57"]= array   (1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0);
    $this->ch_a["37"]= array   (1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0);
    $this->ch_a["m37"]= array  (1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0);
    $this->ch_a["mmaj7"]=array (1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1);
    $this->ch_a["+9"]=   array (1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0);
    $this->ch_a["7+9"]=  array (1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 0);
    $this->ch_a["maj7+9"]=array(1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1);
    // Chord types
    $this->ch_a_type[""]=3;
    $this->ch_a_type["7"]=4;
    $this->ch_a_type["maj7"]=5;
    $this->ch_a_type["mmaj7"]=5;
    $this->ch_a_type["m"]=3;
    $this->ch_a_type["m7"]=4;
    $this->ch_a_type["o"]=5;
    $this->ch_a_type["o7"]=5;
    $this->ch_a_type["%7"]=5;
    $this->ch_a_type["d"]=5;
    $this->ch_a_type["aug"]=5;
    $this->ch_a_type["aug7"]=5;
    $this->ch_a_type["7b9"]=5;
    $this->ch_a_type["mb9"]=5;
    $this->ch_a_type["m7b9"]=5;
    $this->ch_a_type["ad9"]=5;
    $this->ch_a_type["ad13"]=5;
    $this->ch_a_type["9"]=5;
    $this->ch_a_type["13"]=5;
    $this->ch_a_type["mad9"]=5;
    $this->ch_a_type["mad13"]=5;
    $this->ch_a_type["m9"]=5;
    $this->ch_a_type["m13"]=5;
    $this->ch_a_type["sus4"]=5;
    $this->ch_a_type["sus2"]=5;
    $this->ch_a_type["7sus4"]=5;
    $this->ch_a_type["7sus2"]=5;
    $this->ch_a_type["maj7sus4"]=5;
    $this->ch_a_type["maj7sus2"]=5;
    $this->ch_a_type["57"]=4;
    $this->ch_a_type["37"]=4;
    $this->ch_a_type["m37"]=4;
    $this->ch_a_type["+9"]=5;
    $this->ch_a_type["7+9"]=5;
    $this->ch_a_type["maj7+9"]=5;
    // Pause_p is multiplied based on time and chord type
    $this->pause_ch_mul[  0] = array(1 => 3, 2 => 3, 3 => 3, 4 => 2, 5 => 0.2, 6 => 0.2);
    $this->pause_ch_mul[ 60] = array(1 => 3, 2 => 3, 3 => 3, 4 => 2, 5 => 0.2, 6 => 0.2);
    $this->pause_ch_mul_def  = array(1 => 3, 2 => 3, 3 => 3, 4 => 2, 5 => 0.2, 6 => 0.2);
    $this->log_handle=fopen("temp2.log", "w");
  }
  
  function CreateNotes($i, $note, $na) {
    $this->note[0][$i] = $note;
    for ($v=1; $v<count($na)+1; $v++) {
      $this->note[$v][$i]=$this->note[$v-1][$i]+$na[$v-1];
    }
  }
  
  function SetMode($i, $mode_key) {
    $this->mode_key[$i] = $mode_key;
    $this->mode_sig[$i] = midi_sig($this->mode_key[$i]);
    $this->mode[$i] = make_key_na($this->mode_key[$i]);
  }
  
  protected function log($st) {
    fwrite($this->log_handle, $st."\r\n");
  }
  
  protected function StartTimer() {
    $mtime = microtime();
    $mtime = explode(" ",$mtime);
    $mtime = $mtime[1] + $mtime[0];
    $this->mtime_start = $mtime;
  }
  
  protected function RecordTimer($i) {
    $mtime = microtime();
    $mtime = explode(" ",$mtime);
    $mtime = $mtime[1] + $mtime[0];
    $endtime = $mtime;
    $this->mtime[$i] = $endtime - $this->mtime_start;
  }

}

?>
