<?
$nnames = array ("C", "C#", "D", "D#", "E", "F", "F#", "G", "G#", "A", "A#", "H");
//                     C     D     E  F     G     A     H
$diatonic_na = array  (1, 0, 1, 0, 1, 1, 0, 1, 0, 1, 0, 1);
$t_na =        array  (1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0);
$d_na =        array  (0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 1);
$s_na =        array  (1, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0);
//$len_poss = array (1, 2, 4, 8, 12, 16, 24, 32, 64);
$len_poss = array (1, 2, 4, 8, 10, 12, 14, 16, 20, 24, 32, 64);

$colors = array ("lightgreen", "yellow", "pink", "red");

$global_b=0;

function zero($x) {
  if (!isset($x)) return 1;
  if ($x==0) return 1;
  return 0;
}

function one($x) {
  if (!isset($x)) return 0;
  if ($x==1) return 1;
  return 0;
}


function rnd($x1, $x2) {
  return ($x2-$x1)*(mt_rand()/mt_getrandmax())+$x1;
}

function convert_b($st, $b=2) {
  global $global_b;
  if ($b==0) return $st;
  if ((!$global_b) && ($b==2)) return $st;
  $st=str_replace("C#", "Db", $st);
  $st=str_replace("D#", "Eb", $st);
  $st=str_replace("F#", "Gb", $st);
  $st=str_replace("G#", "Ab", $st);
  $st=str_replace("A#", "Bb", $st);
  return $st;
}

function get_notename($nn, $b=0) {
  global $nnames;
  return convert_b($nnames[$nn], $b);
}

function make_vertical($n) {
  $st="$n";
  $st2="";
  for ($i=0; $i<strlen($st); $i++) $st2 .= $st[$i]."&#x200A;";
  return $st2;
}

function make_key_na($key) {
  global $diatonic_na;
  for ($i=0; $i<12; $i++) $na[($i+$key)%12]=$diatonic_na[$i];
  return $na;
}

function mode_walk($mode, $note, $vel) {
  //echo "|$note|$vel|<br>";
  // Check if it is pause, then return pause
  if ($note==0) return 0;
  $p2=$note;
  if ($vel<0) $sign=-1; else $sign=1;
  if ($vel==0) return $p2;
  // For each step move diatonically
  for ($y=0; $y<abs($vel); $y++) {
    for ($x=1; $x<12; $x++) {
      $p2+=$sign;
      //echo "/$sign/$p2/".($p2%12)."/".$mode[$p2%12]."/<br>";
      if ($mode[$p2 % 12]==1) break;
    }
  }
  return $p2;
}

// This function implements discrete random generator with fixed probabilities for each discrete variant, 
// which are passed as an array $pa, where key is variant and (value/sum(values)) is probability of the variant.
function rand_pa($pa) {
  $sum=array_sum($pa);
  $rv=rnd(0, $sum-1); // random value
  $m1=0; // limits of probability for each variant
  $m2=0;
  foreach ($pa as $key => $value) {
    //if ($m2==0) $res=$key;
    $m1=$m2; // where one variant ends, next one starts
    $m2+=$value; // count upper limit for variant
    if (($value>0) && ($rv >= $m1) && ($rv < $m2)) {
      $res=$key;
      break;
    }
  }
  return $res;
}

function make_color($r, $g=-1, $b=-1)
{
  if (is_array($r) && sizeof($r) == 3)
      list($r, $g, $b) = $r;

  $r = intval($r); $g = intval($g);
  $b = intval($b);

  $r = dechex($r<0?0:($r>255?255:$r));
  $g = dechex($g<0?0:($g>255?255:$g));
  $b = dechex($b<0?0:($b>255?255:$b));

  $color = (strlen($r) < 2?'0':'').$r;
  $color .= (strlen($g) < 2?'0':'').$g;
  $color .= (strlen($b) < 2?'0':'').$b;
  return '#'.$color;
}

function compare_na($na1, $na2, $shift=0) {
  $dif=0;
  for ($x=0; $x<12; $x++) {
    $p=($x+$shift)%12;
    if (($na1[$x] >0) && ($na2[$p] ==0)) $dif += 1;
    if (($na1[$x] ==0) && ($na2[$p] >0)) $dif += 1;
  }
  return $dif;
}

function mul_na($na1, $na2, $shift=0) {
  $mul=0;
  for ($x=0; $x<12; $x++) {
    $n1 = $na1[$x];
    $n2 = $na2[($x+$shift)%12];
    if ($n1 >  0) {
      if ($n2 >  0) $mul += $n1*$n2;
      else $mul -= $n1/2;
    } else {
      if ($n2 >  0) $mul -= $n2/2;
    }
  }
  return $mul;
}

function midi_sig($key) {
  $key2=0;
  for ($x=0; $x<7; $x++) {
    if ($key2==$key) return $x;
    $key2=($key2+7) % 12;
  }
  $key2=0;
  for ($x=0; $x<7; $x++) {
    if ($key2==$key) return -$x;
    $key2=($key2-7) % 12;
    if ($key2<0) $key2 += 12;
  }
}

function myexec($path, $fh) {
  //$output = shell_exec( $path );
  exec( $path, $ra, $rv );
  for ($x=0; $x<count($ra); $x++) $output .= $ra[$x]." ";
  $path = iconv("cp866", "windows-1251", $path);
  $output = iconv("cp866", "windows-1251", $output);
  echo $path."<br>";
  fwrite($fh, $path."\r\n");
  if ($rv != 0) echo "<font color=red>";
  else echo "<font color=green>";
  echo "<b>";
  echo "Output: ". $output."<br>";
  echo "</font></b>";
  fwrite($fh, $output."\r\n");
}

function save_project($pname) {
  $date=date("Y-m-d");
  if (is_dir("$date-$pname")) {
    echo "<font color=red><b>Directory already exists: $date-$pname<br>Not saved to protect your previous project!</b></font>";
    exit;
  }
	echo "Saving project: <a href='$date-$pname'>$date-$pname</a><br>";
  mkdir($date."-".$pname);
  mkdir($date."-".$pname."/php");
  mkdir($date."-".$pname."/images");
  $cmd="cp";
  $param="2>&1";
  $fh=fopen("temp.log", "w");
  myexec( " $cmd *.php $date-$pname/php/ $param " , $fh );
  myexec( " $cmd *.log $date-$pname/ $param " , $fh );
  myexec( " $cmd temp-midi.txt $date-$pname/$pname.txt $param " , $fh );
  myexec( " $cmd temp-midi-sib.txt $date-$pname/$pname-sib.txt $param " , $fh );
  myexec( " $cmd temp.mid $date-$pname/$pname.mid $param " , $fh );
  myexec( " $cmd temp-sib.mid $date-$pname/$pname-sib.mid $param " , $fh );
  myexec( " $cmd temp.html $date-$pname/$pname.html $param " , $fh );
  myexec( " $cmd images/* $date-$pname/images/ $param " , $fh );
  myexec( " $cmd -r overlibmws $date-$pname/ $param " , $fh );
  mkdir($date."-".$pname."/overlibmws");
  $cmd="copy";
  $param="";
  myexec( " $cmd *.php \"$date-$pname/php/\" $param ", $fh );
  myexec( " $cmd *.log \"$date-$pname/\" $param ", $fh );
  myexec( " $cmd temp-midi.txt \"$date-$pname/$pname.txt\" $param " , $fh );
  myexec( " $cmd temp-midi-sib.txt \"$date-$pname/$pname-sib.txt\" $param " , $fh );
  myexec( " $cmd temp.mid \"$date-$pname/$pname.mid\" $param " , $fh );
  myexec( " $cmd temp-sib.mid \"$date-$pname/$pname-sib.mid\" $param " , $fh );
  myexec( " $cmd temp.html \"$date-$pname/$pname.html\" $param " , $fh );
  myexec( " $cmd images\* \"$date-$pname/images\" $param " , $fh );
  myexec( " $cmd overlibmws\* \"$date-$pname/overlibmws\" $param " , $fh );
  fclose($fh);
	echo "Project saved";
}
?>
